stages:
  - build

build:
  image: docker
  stage: build
  script:
    - if [ -n "$CI_COMMIT_TAG" ]; then
        image_tagged="$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG";
      else
        image_tagged="$CI_REGISTRY_IMAGE:latest";
      fi
    - echo "Building image for tag $image_tagged"
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
    - docker context create myBuilder
    - docker buildx create myBuilder --use
    - docker buildx build --platform linux/amd64 --tag "$image_tagged" --push .
  rules:
    - if: '$BUILD_DISABLED'
      when: never
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH'

# build arm64 image
build_arm64:
  image: docker
  stage: build
  timeout: 200 minutes
  script:
    - if [ -n "$CI_COMMIT_TAG" ]; then
        image_tagged="$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG";
      else
        image_tagged="$CI_REGISTRY_IMAGE:latest";
      fi
    - echo "Building image for tag $image_tagged"
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker run --rm --privileged multiarch/qemu-user-static --reset -p yes
    - docker context create myBuilder
    - docker buildx create myBuilder --use
    - docker buildx build --platform linux/arm64 --tag "$image_tagged" --push .
  rules:
    - when: manual
